using namespace std;

#include <unordered_set>
#include <queue>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_n = opt<int>("n");
    int max_m = opt<int>("m");

    int n = 1 + rnd.wnext(max_n, 3);
    int m = 1 + rnd.wnext(min(max_m, n * (n - 1) / 2 + 1), 3);
    int rc = has_opt("r") ? opt<int>("r") : 2;
    printf("%d %d\n", n, m);
    for (int i = 0; i < n; ++i) {
        if (i > 0) { printf(" "); }
        printf("%d", rnd.next(1, 2));
    }
    printf("\n");
    int rc1num = rc == 1 ? rnd.next(0, n - 1) : 0;
    for (int i = 0; i < n; ++i) {
        if (i > 0) { printf(" "); }
        if (rc == 0) {
            printf("%d", 0);
        } else if (rc == 1) {
            printf("%d", rc1num == i ? 1 : 0);
        } else {
            printf("%d", rnd.next(0, 1));
        }
    }
    printf("\n");

    set <pair<int, int >> was_edge;
    for (int i = 0; i < m; ++i) {
        while (true) {
            int u = rnd.next(1, n);
            int v = rnd.next(1, n - 1);
            v = v >= u ? v + 1 : v;
            if (was_edge.find(make_pair(min(u, v), max(u, v))) == was_edge.end()) {
                printf("%d %d\n", u, v);
                break;
            }
        }
    }
}

