/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

int main() {

    in(int, n)
    vector<pll> rects(n);
    cin >> rects;

    vector<pll> opts{rects[0]}, next_opts;
    for (int i = 1; i < n; i++) {
        auto const &rect = rects[i];
        for (auto const &opt: opts) {
            if (opt.first == rect.first || opt.first == rect.second) {
                ll delta = opt.first == rect.first ? rect.second : rect.first;
                ll a = opt.first, b = opt.second + delta;
                if (a > b) swap(a, b);
                next_opts.emplace_back(a, b);
            }
            if (opt.second == rect.first || opt.second == rect.second) {
                ll delta = opt.second == rect.first ? rect.second : rect.first;
                ll a = opt.second, b = opt.first + delta;
                if (a > b) swap(a, b);
                next_opts.emplace_back(a, b);
            }
        }
        next_opts.resize(unique(all(next_opts)) - next_opts.begin());
        swap(opts, next_opts);
        next_opts.clear();
    }

    cout << opts.size() << '\n';
    for (auto const &opt: opts) {
        cout << opt.first << ' ' << opt.second << '\n';
    }

}